%% test BIL
% Implements the example used in http://arxiv.org/pdf/1312.2060v1.pdf
close all
clc
clear all
N=240; % # measurements
n=40; % # basis functions

%% Generate data
e0=2*(rand(N,1)-0.5);
x0=randn(n,1);
na=1;
nb=3;
p=6;
D=randn(N,n);
D=eye(N,N);
A=eye(n,n);D=[];
for i=1:n
    D(p*i-p+1:p*i,:)=ones(p,1)*A(i,:);
end
b=[1 2 3];
u=D*x0;
a=-0.3;
y=zeros(N,1);
yn=zeros(N,1);
for t=nb:N
    yn(t)=b*u(t-nb+1:t)+a*y(t-1);
    y(t)=b*u(t-nb+1:t)+a*y(t-1)+e0(t);
end

%% Run BIL
lambda=1;
[uhat, ahat, bhat] = BIL(y,D,na,nb,lambda);
w=uhat'/u';

%% Display results
disp('par values:')
[ahat' a']
[bhat*w b(end:-1:1)']
disp('Number of coefficients: ')
na+nb+n
disp('Number of measurements :')
N
